package Resources;

import POJO.PromptPOJO;
import io.restassured.path.json.JsonPath;
import io.restassured.response.Response;

import java.io.*;

public class TestData {
    PromptPOJO prompt = new PromptPOJO();
   public String prompt(String input){
       prompt.setModel("llama3.2:latest");
       prompt.setStream(false);
       prompt.setPrompt(input);
       return prompt.toString();
   }

   public String errorPrompt(String error, String file) throws IOException {
       String content = formatErrorMessage(error);
       System.out.println(content);
       writeStringToFile(content, file);
       prompt.setModel("llama3.2:latest");
       prompt.setStream(false);
       prompt.setPrompt(readFromFile(file));
    return prompt.toString();
   }
    public void writeStringToFile(String content, String fileName) throws IOException {
        BufferedWriter writer = new BufferedWriter(new FileWriter(fileName));
        writer.write(content);
        writer.close();
        System.out.println("Content written to file " +fileName);
    }

    public String readFromFile(String fileName) throws IOException {
        BufferedReader reader = new BufferedReader(new FileReader(fileName));
        StringBuilder prompt = new StringBuilder();
        String line;
        while ((line= reader.readLine())!= null){
            prompt.append(line).append("\n");
        }
        reader.close();
        System.out.println("Read from file: " + fileName);
        return prompt.toString().trim();
    }

    public static String formatErrorMessage(String errorMessage) {
        String formattedString = errorMessage.replace("\"", "\\\"")
                .replace("\n", "\\n")
                .replace("\r", "\\r")
                .replace("\t", "\\t");
        return  formattedString;
    }


    public static String getJsonPath(Response response, String key) {
        String resp = response.asString();
        JsonPath js = new JsonPath(resp);
        return js.get(key).toString();
    }

    public static String convertStringToBulletPoints(String llmResponse) {
        llmResponse = llmResponse.trim();
        if (llmResponse.isEmpty()) {
            return "No content to convert.";
        }
        String[] sentences = llmResponse.split("(?<=\\. )\\s*");
        StringBuilder bulletPoints = new StringBuilder();
        for (String sentence : sentences) {
            String trimmedSentence = sentence.trim();
            if (!trimmedSentence.isEmpty()) {
                bulletPoints.append("• ").append(trimmedSentence.trim()).append("\n");
            }
        }
        return bulletPoints.toString();
    }

    public static String convertToBulletPoints(String llmResponse) {
        llmResponse = llmResponse.trim();
        if (llmResponse.isEmpty()) {
            return "No content to convert.";
        }
        StringBuilder bulletPoints = new StringBuilder();
        StringBuilder sentence = new StringBuilder();
        for (int i = 0; i < llmResponse.length(); i++) {
            char currentChar = llmResponse.charAt(i);
            sentence.append(currentChar);
            if (currentChar == '.') {
                String sentenceStr = sentence.toString().trim();
                if (!sentenceStr.isEmpty()) {
                    bulletPoints.append("• ").append(sentenceStr).append("\n");
                }
                sentence.setLength(0);
            }
        }
        String remainingSentence = sentence.toString().trim();
        if (!remainingSentence.isEmpty()) {
            bulletPoints.append("• ").append(remainingSentence).append("\n");
        }
        return bulletPoints.toString();
    }




    public static void main(String[] args) throws IOException {

    }
}


